分类: 技术
-
RQNOJ 47 [NOIP2003]神经网络
算法本质:SPFA 算法描述:网上有一些人的代码是错的,只怪NOIP这种破竞赛的难度太低,数据太差,导致他们都可以溜过去了,但是有不少人的代码都是不能够AC的代码,他们利用图的进度来判断是否能够加入SPFA的列队,那么特殊情况,当有一个神经节点无法发送信号时,它后面的所有节点不都死翘翘了,迟迟不能进入列队,你们可以测试一下这一组数据:
de> 5 5 1 0 0 1 0 0 0 0 0 0 1 2 1 1 3 1 2 4 1 3 4 1 4 5 1 de> 思路其实还是很简单的,就是一层一层的枚举,当入读为0就入列队,如果c[i]<0 ON co de lang="C">#include #include #define MAX 200 int n, p; int f[MAX]; int map[MAX][MAX]; int link[MAX][MAX]; int lenth[MAX], in[MAX]; void add(int a, int b, int c) { link[a][lenth[a]] = b; map[a][lenth[a]] = c; lenth[a]++; in[b]++; } int queue[MAX]; int end, head; void enqueue(int i) { queue[end++] = i; } int exqueue(void) { return queue[head++]; } int main(int argc, char *argv[]) { int t, s, l; int i; scanf("%d%d", &n, &p); for(i = 0; i 0){ enqueue(i); }else{ f[i] = -t; } } for(i = 0; i 0){ printf("%d %d\n", i + 1, f[i]); l = 0; } } if(l){ printf("NULL\n"); } return 0; } de> -
USACO 3.4.4 Raucous Rockers 解题报告
题目本质:动态规划?枚举?都像 算法描述:用f[i][j][k] 代表第i张碟子装了长度为j的歌, 而且最后一首是k。具体的方程看代码吧 复杂度:时间O(n^4), 空间O(n^3)
/ LANG: C ID: yylogoo1 PROG: rockers / #include#include #define MAX 21 int num[MAX]; int f[MAX][MAX][MAX]; int ans; int n, t, m; int main(int argc, char *argv[]) { int i, j, k, l; freopen("rockers.in", "r", stdin); freopen("rockers.out", "w", stdout); scanf("%d%d%d", &n, &t, &m); for(i = 1; i f[i][j + num[l]][l]){ f[i][j + num[l]][l] = f[i][j][k] + 1; } }else{ if(f[i][j][k] + 1 < f[i + 1][num[l]][l]){ f[i + 1][num[l]][l] = f[i][j][k] + 1; } } } if(ans -
SGU 105 Div 3 解题
算法本质:数学 算法描述:有这么一条数学公式,小学学的,把所有位数上的数加起来,如果能被三整除那么这个数就能被三整除,那么就很方便了,因为题目是相邻的数字相乘,那么题目所描述的数列每隔3个就会有2个能被3整出。 复杂度:时间&空间:O(1)
#include#include int num[3] = {0, 0, 1}; int main(int argc, char argv[]) { int n; scanf("%d", &n); printf("%d\n", n / 3 2 + num[n % 3]); return 0; } -
USACO 3.4.3 Electric Fence 解题报告
题目本质:相似三角形+枚举 算法描述:题目给出的三角形比较特殊,所以可以直接枚举,当然也不能说是直接枚举咯。我的算法是,对于每一行进行枚举,但是很快就到瓶颈了,无法确定坐标,虽然能够画出相似三角形,因为三角形的一条边在x轴上,所以从y等于(-)1(看情况而定是1还是-1)至m,每一行做与x轴平行的线就有相似三角形了,但是只能确定长短,不能确定坐标,后来想了好阵子,才想到,用高来确定坐标,用两个三角形,(n, m)(n, 0)(0, 0),(m, n)(n, 0)(p, 0),分别可以把新坐标求出来,然后一个向上取整,一个向下取整,相减+1就可以了,接下来就是细节了。 Pay attention:y=0 不计算,x轴上所有的点都在线上,不符合要求;如果在某个y上,x1, x2(相似三角形求出的两个坐标), x1, x2为整数的话, 那么x1, x2连点都不能取。 复 杂 度:这题不会分析,不知道什么是N。
de lang="c">/ LANG: C ID: yylogoo1 PROG: fence9 / #include #include #include -
SGU 104 Little Shop of Flowers 解题
本 质:动态规划 算法描述:f[i][j] = max(f[i – 1][j – 1] + num[i][j], f[i][j – 1]) 方程十分简单,但是我久久不能AC,看了别人的代码也没看懂为什么初始需要f[i][i] = f[i – 1][i – 1] + num[i][i] 后来才想通,如果num[i][i]有一个负数,那就可能无解,所以要这么弄下,代码如下:
de lang="c">#include #include int num[101][101]; int ans[101][101]; int g[101][101]; int a[100]; int end; int max(int a, int b) { return a < b ? a : b; } void output(int f, int v, int k) { int i; for(i = v; i <= 1; i–){ if(ans[f][i – 1] != k){ break; } } if(f == 1){ printf("%d", i); return; } output(f – 1, i – 1, ans[f][i] – num[f][i]); printf(" %d", i); } int main(int argc, char *argv[]) { int i, j; int f, v; // freopen("tmp", "r", stdin); scanf("%d%d", &f, &v); for(i = 1; i -
USACO 3.4.2 American Heritage 解题报告
算法本质:树的遍历性质和深搜 算 法:先从中序遍历找出哪一个是根,即在先序遍历中下标最小的那个节点,这个节点向左就是左子树,向右就是右子树。 复杂度:空间&时间O(n)
/ LANG:C ID: yylgoo1 PROG: heritage / #include#include #include #define INF 0x7FFFFFFF char a[27], b[27]; int or[26]; void srch(int start, int end) { int i; int mid = -1, min = INF; if(start < end){ return; } for(i = start; i or[a[i] - 'A']){ min = or[a[i] - 'A']; mid = i; } } srch(start, mid - 1); srch(mid + 1, end); printf("%c", a[mid]); } int main(void) { int i, len; freopen("heritage.in", "r", stdin); freopen("heritage.out", "w", stdout); scanf("%s%s", a, b); len = strlen(a); for(i = 0; i <len i orbi - A="i;" srch len - printfn return code> -
SGU 103 Traffic Lights 解题报告
算法本质:单源最短路径+简单变形 算 法: 就是单源最短路径,我使用的SPFA,但是和普通单源最短路径不同的是,这个需要把路上所消耗的时间加上等待两边的灯同时亮起的时间这样唯一要耽误点时间实现的就是计算等待的时间。 计算在时间k通过a,b两个路口所需要等待的时间算法如下,如果此时(k)a,b路口的路灯是相同的话那么等待时间为0,如果不同那么就是a路口灯光变色的时间和b路口灯光变色的时间二者的最小时间,但是如果二者相同的话,那么就继续循环,此时k就等于a(或者b)路口灯光变色的时间。 复 杂 度: 时间&空间:O(N^2)
de lang="C">#include #include #include #define MAX 300 / 添加这些注释 / #define INF 0x7FFFFFFF struct node{ int color, wait; int wait_1, wait_2; }node[301]; int map[301][300]; int link[301][300]; int count[301]; int queue[300]; int used[301], from[301]; int head, rear; int dist[301]; int min(int a, int b) { return a c + map[a][i]){ dist[b] = c + map[a][i]; from[b] = a; enqueue(b); } } } if(dist[end] == INF){ printf("0\n"); return 0; } printf("%d\n", dist[end]); output(start, end); printf("\n"); return 0; } de> -
USACO 3.3.5 A Game 解题报告
本质:动态规划 算法:f[i][j]代表从(i, j)能取的最大值,sum[i][j]代表它们的总和 f[i][j] = sum[i][j] – min(f[i + 1][j], f[i][j – 1]); 复杂度: 时间&空间:O(N^2)
de lang="c">/ LANG: C ID: yylogoo1 PROG: game1 / #include int sum[100][100]; int f[100][100]; int min(int a, int b) { return a